!function(win,widget){
    var Event = lib.event,Http = lib.http;
    function goods(goodsModel){
        var _defaultGoodsModel = {
            goods_id:0,
            goods_name:'',
            goods_spec:{
                //{颜色: ["银色", "黑色"], 尺寸: ["35", "38"]}
                //
            },
            img:'',
            product_list:[],
            direct_rate:1
        };
        var _this = this;

        var selectedSpecs = [],deliveryAddressId;

        var stockInfo = {}, specs2productId = {},totalStock = 0,defaultPrice = 0,freight = 0,productId=false,direct_rate = 1;

        goodsModel = $.extend({},_defaultGoodsModel,goodsModel);

        totalStock = (function(product_list){
            var result = 0;
            for(var i=0;i<product_list.length;i++){
                result +=Number(product_list[i]['stock']);
            }
            return result;
        })(goodsModel.product_list);
        defaultPrice = goodsModel.max_retail_price;
        direct_rate = goodsModel.direct_rate;


        function floorIncome(number){
            return (Math.floor(number*100)/100).toFixed(2);
        }

        function formatSpecKeysString(specKeysString){
            var specKeysArr = specKeysString.split('|');
            specKeysArr.sort(function(a,b){
                return b-a;
            });
            return specKeysArr.join('|');
        }

        function parseProductInfo (originProductList){
            for(var i=0;i<originProductList.length;i++){
                var row = originProductList[i];
                var productId = row['product_id'];
                var specKey = formatSpecKeysString(row.spec_value);
                specs2productId[specKey] = productId;
                stockInfo[productId] = {
                    stock:row.stock,
                    offline_price:row.offline_price,
                    price:row.sales_price,
                    market_price:row.market_price,
                    specs:specKey,
                    income:row.direct_comm_val
                };
            }
            return stockInfo;
        }

        function getGoodsId(){
            return goodsModel.goods_id;
        }
        function getProductId(){
            return productId;
        }

        function setSelectedSpecs (selectedSpecsArr){
            var _productId;
            if($.isEmptyObject(goodsModel.goods_spec)&&goodsModel.product_list.length===1){
                _productId = goodsModel.product_list[0]['product_id'];
            }else{
                selectedSpecsArr.sort(function(a,b){
                    return b-a;
                });
                selectedSpecs = selectedSpecsArr;
                _productId = specs2productId[selectedSpecsArr.join('|')] ;
            }
            if(productId != _productId){
                productId = _productId;
                _this.dispatchEvent({
                    type:'salesChanged',
                    target:this
                });
            }
        }

        function getSalesInfo(){
            var productId = getProductId();
            if(stockInfo[productId]){
                return stockInfo[productId];
            }else{
                return false;
            }
        }

        function getProductList(){
            return stockInfo;
        }

        function getDisInfoByProdId(productId){
            return goodsModel.dis_price[productId]||{};
        }

        stockInfo = parseProductInfo(goodsModel.product_list);

        this.getDisInfoByProdId = getDisInfoByProdId;
        this.setSelectedSpecs = setSelectedSpecs;
        this.getSalesInfo = getSalesInfo;
        this.getProductId = getProductId;
        this.getProductList = getProductList;
        this.getGoodsId = getGoodsId;

    }
    Event.extend.call(goods);
    widget.goods = goods;
}(window, window['widget'] || (window['widget'] = {}));