!function(win,widget){
    function toNumber(value,min,max){
        value = value.toString().replace(/\D/g,'');
        return parseInt(value||0);
    }
    function counter(options){
        var _default = {
            counter:'.counter',
            min:1,
            max:999,
            change:null
        };
        options = $.extend({},_default,options);
        var min = options.min,max = options.max;
        function setValue(number,number2){
            number = toNumber(number);
            if(typeof(number2) === 'undefined')number2=0;
            number += number2;
            if(number < min){
                number = min;
            }else if(number > max){
                number = max;
            }
            $input.val(number);
            $inputText.text(number);
            if(typeof(options.change) == 'function')options.change(number);
        }
        function getValue(){
            var number = toNumber($input.val());
            if(number < min){
                number = min;
            }else if(number > max){
                number = max;
            }
            return number;
        }
        var $counter = $(options.counter);
        var $input = $counter.find('input[type=text]'),
            $inputText = $('<span class="input-text">'+$input.val()+'</span>'),
            $reduce  = $counter.find('.minus'),
            $add  = $counter.find('.plus');
        var st;
        $input.attr('type','hidden').before($inputText);
        $reduce.on('tap',function(event){
            if($input.attr('disabled')!='disabled')setValue($input.val(),-1);
            return false;
        });
        $add.on('tap',function(event){
            if($input.attr('disabled')!='disabled')setValue($input.val(),1);
            return false;
        });
        this.val  = function(number){
            if(typeof(number) == 'undefined'){
                return getValue();
            }else{
                return setValue(number);
            }
        };
        this.setMax = function(number){
            max = number;
            if(min>max){
                min=max;
            }else{
                min=1;
            }
            setValue($input.val());
        };
        this.setMin = function(number){
            min = number;
            if(max>min)max=min;
            setValue($input.val());
        };
    };
    widget.counter = counter;
}(window,window['widget'] || (window['widget'] = {}));